// Connector.cpp : Defines the entry point for the console application.
//

#include "stdafx.h"

using namespace std;


int main(int argc, char* argv[]){

	if(argc != 3){
		cout<<"BAD ARGUMENTS"<<endl;
		return 0;
	}
    MYSQL *connection, mysql;
    MYSQL_RES *result; 
    MYSQL_ROW row;
    int query_state = -1;
    bool mysql_connected;

	bool registered = false;

	mysql_init(&mysql);
    mysql_connected = true;
    connection = mysql_real_connect(&mysql,"echo.datacentre.sk","c20348dip","password","c20348dip",0,0,0);
	if (connection == NULL) {
		mysql_connected = false;
		cout<<"CONNECTION ERROR"<<endl;
		return 0;
	}
	if(mysql_connected == true){
		my_bool my_true = true;
		mysql_options(connection, MYSQL_OPT_RECONNECT, &my_true);
	}

	char query[1024];
	sprintf(query,"SELECT `id` FROM `c20348dip`.`players` WHERE `name` = '%s' AND `pass` = '%s' LIMIT 1;",argv[1], argv[2]);
	mysql_query(connection, query); //query the database
	result = mysql_use_result(connection); 

	while(row = mysql_fetch_row (result)){
		unsigned long* lengths; 
		lengths = mysql_fetch_lengths (result); 
		if (lengths[0] != 0) 
		{ 
			char buffer[20];
			int id;

			memcpy (buffer, row[0], lengths[0]); 
			buffer[lengths[0]] = 0; 
			sscanf(buffer, "%d", &id);
			cout<<"CONNECTED"<<endl;
			registered = true;
		}
	}

	if( registered == false ){
		sprintf(query, "INSERT INTO `c20348dip`.`players` (`id` ,`name` ,`pass` )VALUES (NULL , '%s', '%s');",argv[1],argv[2]);
		query_state = mysql_query(connection, query);
		
		switch(query_state){
			case 0:
				cout<<"SIGNED"<<endl;
				break;
			case 2014:
				cout<<"CR_COMMANDS_OUT_OF_SYNC"<<endl;
				break;
			case 2006:
				cout<<"CR_SERVER_GONE_ERROR"<<endl;
				break;
			case 2013:
				cout<<"CR_SERVER_LOST"<<endl;
				break;
			case 2000:
				cout<<"CR_UNKNOWN_ERROR"<<endl;
				break;
			default:
				cout<<"OTHER_ERROR: "<<query_state<<endl;
				break;
		}
	}

	sprintf(query,"SELECT name, lap_time FROM   times s1 WHERE  lap_time=(SELECT MIN(s2.lap_time) FROM times s2 WHERE s1.car_type = s2.car_type) ORDER BY s1.car_type DESC;");
	mysql_query(connection, query); //query the database
	result = mysql_use_result(connection); 

	string lap_text1, lap_text2;
	lap_text1 = "--:--.--";
	lap_text2 = "--:--.--";
	string name1, name2;
	name1 = "unknown";
	name2 = "unknown";

	int i = 0;
	while(row = mysql_fetch_row(result)){
		unsigned long* lengths; 
		lengths = mysql_fetch_lengths (result); 
		if (lengths[0] != 0) 
		{ 
			char buffer[20], text[64];
			float lapt, secs;
			int mins;

			memcpy (buffer, row[1], lengths[0]); 
			buffer[lengths[0]] = 0; 
			sscanf(buffer, "%f", &lapt);

			mins = lapt/60;
			secs = lapt - 60*mins;
			sprintf(text,"%d:%06.3f",mins,secs);
			if(i == 0){
				lap_text1 = text;
				name1 = row[0];
			}
			else{
				lap_text2 = text;
				name2 = row[0];
			}

			i++;
		}
	}

	cout<<name1.c_str()<<endl<<lap_text1.c_str()<<endl<<name2.c_str()<<endl<<lap_text2.c_str();

	return 0;
}

